##############################################################################
# cgissl.py 0.4.1
# (C) 1998 by Michael Stroeder
##############################################################################

import sys, os, re, string, charset

def GetAllSSLEnviron():

  SSLEnv = {}

  HTTPS = os.environ.get('HTTPS','off')
  if HTTPS=='on':

    SSLEnv['SSL_CIPHER_ALGKEYSIZE'] = \
      os.environ.get('SSL_CIPHER_ALGKEYSIZE',
      os.environ.get('HTTPS_KEYSIZE',
      os.environ.get('SSL_KEYSIZE',
      os.environ.get('SSL_SERVER_KEY_SIZE',
      ''))))
    SSLEnv['SSL_CIPHER_EXPORT'] = \
      os.environ.get('SSL_CIPHER_EXPORT',
      os.environ.get('HTTPS_EXPORT',
      os.environ.get('SSL_EXPORT',
      '')))
    SSLEnv['SSL_CIPHER'] = \
      os.environ.get('SSL_CIPHER',
      os.environ.get('HTTPS_CIPHER',
      ''))
    SSLEnv['SSL_CIPHER_USEKEYSIZE'] = \
      os.environ.get('SSL_CIPHER_USEKEYSIZE',
      os.environ.get('HTTPS_SECRETKEYSIZE',
      os.environ.get('SSL_SECKEYSIZE',
      '')))
    SSLEnv['SSL_CLIENT_A_SIG'] = \
      os.environ.get('SSL_CLIENT_A_SIG',
      os.environ.get('SSL_CLIENT_SIGNATURE_ALGORITHM',
      ''))
    SSLEnv['SSL_CLIENT_CERT'] = \
      os.environ.get('SSL_CLIENT_CERT',
      os.environ.get('SSL_CLIENT_CERTIFICATE',
      ''))
    SSLEnv['SSL_CLIENT_I_DN'] = \
      os.environ.get('SSL_CLIENT_I_DN',
      os.environ.get('SSL_CLIENT_IDN',
      ''))
    SSLEnv['SSL_CLIENT_I_DN_CN'] = \
      os.environ.get('SSL_CLIENT_I_DN_CN',
      os.environ.get('SSL_CLIENT_ICN',
      ''))
    SSLEnv['SSL_CLIENT_I_DN_C'] = \
      os.environ.get('SSL_CLIENT_I_DN_C',
      os.environ.get('SSL_CLIENT_IC',
      ''))
    SSLEnv['SSL_CLIENT_I_DN_Email'] = \
      os.environ.get('SSL_CLIENT_I_DN_Email',
      os.environ.get('SSL_CLIENT_IEMAIL',
      ''))
    SSLEnv['SSL_CLIENT_I_DN_L'] = \
      os.environ.get('SSL_CLIENT_I_DN_L',
      os.environ.get('SSL_CLIENT_IL',
      ''))
    SSLEnv['SSL_CLIENT_I_DN_O'] = \
      os.environ.get('SSL_CLIENT_I_DN_O',
      os.environ.get('SSL_CLIENT_IO',
      ''))
    SSLEnv['SSL_CLIENT_I_DN_OU'] = \
      os.environ.get('SSL_CLIENT_I_DN_OU',
      os.environ.get('SSL_CLIENT_IOU',
      ''))
    SSLEnv['SSL_CLIENT_I_DN_SP'] = \
      os.environ.get('SSL_CLIENT_I_DN_SP',
      os.environ.get('SSL_CLIENT_ISP',
      ''))
    SSLEnv['SSL_CLIENT_M_SERIAL'] = \
      os.environ.get('SSL_CLIENT_M_SERIAL',
      os.environ.get('SSL_CLIENT_CERT_SERIAL',
      ''))
    SSLEnv['SSL_CLIENT_S_DN'] = \
      os.environ.get('SSL_CLIENT_S_DN',
      os.environ.get('SSL_CLIENT_DN',
      ''))
    SSLEnv['SSL_CLIENT_S_DN_CN'] = \
      os.environ.get('SSL_CLIENT_S_DN_CN',
      os.environ.get('SSL_CLIENT_CN',
      ''))
    SSLEnv['SSL_CLIENT_S_DN_C'] = \
      os.environ.get('SSL_CLIENT_S_DN_C',
      os.environ.get('SSL_CLIENT_C',
      ''))
    SSLEnv['SSL_CLIENT_S_DN_Email'] = \
      os.environ.get('SSL_CLIENT_S_DN_Email',
      os.environ.get('SSL_CLIENT_EMAIL',
      ''))
    SSLEnv['SSL_CLIENT_S_DN_L'] = \
      os.environ.get('SSL_CLIENT_S_DN_L',
      os.environ.get('SSL_CLIENT_L',
      ''))
    SSLEnv['SSL_CLIENT_S_DN_O'] = \
      os.environ.get('SSL_CLIENT_S_DN_O',
      os.environ.get('SSL_CLIENT_O',
      ''))
    SSLEnv['SSL_CLIENT_S_DN_OU'] = \
      os.environ.get('SSL_CLIENT_S_DN_OU',
      os.environ.get('SSL_CLIENT_OU',
      ''))
    SSLEnv['SSL_CLIENT_S_DN_SP'] = \
      os.environ.get('SSL_CLIENT_S_DN_SP',
      os.environ.get('SSL_CLIENT_SP',
      ''))
    SSLEnv['SSL_CLIENT_V_END'] = \
      os.environ.get('SSL_CLIENT_V_END',
      os.environ.get('SSL_CLIENT_CERT_END',
      ''))
    SSLEnv['SSL_CLIENT_V_START'] = \
      os.environ.get('SSL_CLIENT_V_START',
      os.environ.get('SSL_CLIENT_CERT_START',
      ''))
    SSLEnv['SSL_PROTOCOL'] = \
      os.environ.get('SSL_PROTOCOL',
      os.environ.get('SSL_PROTOCOL_VERSION',
      ''))
    SSLEnv['SSL_SERVER_A_SIG'] = \
      os.environ.get('SSL_SERVER_A_SIG',
      os.environ.get('SSL_SERVER_SIGNATURE_ALGORITHM',
      ''))
    SSLEnv['SSL_SERVER_CERT'] = \
      os.environ.get('SSL_SERVER_CERT',
      os.environ.get('SSL_SERVER_CERTIFICATE',
      ''))
    SSLEnv['SSL_SERVER_I_DN_CN'] = \
      os.environ.get('SSL_SERVER_I_DN_CN',
      os.environ.get('SSL_SERVER_ICN',
      ''))
    SSLEnv['SSL_SERVER_I_DN_C'] = \
      os.environ.get('SSL_SERVER_I_DN_C',
      os.environ.get('SSL_SERVER_IC',
      ''))
    SSLEnv['SSL_SERVER_I_DN_Email'] = \
      os.environ.get('SSL_SERVER_I_DN_Email',
      os.environ.get('SSL_SERVER_IEMAIL',
      ''))
    SSLEnv['SSL_SERVER_I_DN_L'] = \
      os.environ.get('SSL_SERVER_I_DN_L',
      os.environ.get('SSL_SERVER_IL',
      ''))
    SSLEnv['SSL_SERVER_I_DN_O'] = \
      os.environ.get('SSL_SERVER_I_DN_O',
      os.environ.get('SSL_SERVER_IO',
      ''))
    SSLEnv['SSL_SERVER_I_DN'] = \
      os.environ.get('SSL_SERVER_I_DN',
      os.environ.get('SSL_SERVER_IDN',
      ''))
    SSLEnv['SSL_SERVER_I_DN_OU'] = \
      os.environ.get('SSL_SERVER_I_DN_OU',
      os.environ.get('SSL_SERVER_IOU',
      ''))
    SSLEnv['SSL_SERVER_I_DN_SP'] = \
      os.environ.get('SSL_SERVER_I_DN_SP',
      os.environ.get('SSL_SERVER_ISP',
      ''))
    SSLEnv['SSL_SERVER_M_SERIAL'] = \
      os.environ.get('SSL_SERVER_M_SERIAL',
      os.environ.get('SSL_SERVER_CERT_SERIAL',
      ''))
    SSLEnv['SSL_SERVER_S_DN'] = \
      os.environ.get('SSL_SERVER_S_DN',
      os.environ.get('SSL_SERVER_DN',
      ''))
    SSLEnv['SSL_SERVER_S_DN_CN'] = \
      os.environ.get('SSL_SERVER_S_DN_CN',
      os.environ.get('SSL_SERVER_CN',
      ''))
    SSLEnv['SSL_SERVER_S_DN_C'] = \
      os.environ.get('SSL_SERVER_S_DN_C',
      os.environ.get('SSL_SERVER_C',
      ''))
    SSLEnv['SSL_SERVER_S_DN_Email'] = \
      os.environ.get('SSL_SERVER_S_DN_Email',
      os.environ.get('SSL_SERVER_EMAIL',
      ''))
    SSLEnv['SSL_SERVER_S_DN_L'] = \
      os.environ.get('SSL_SERVER_S_DN_L',
      os.environ.get('SSL_SERVER_L',
      ''))
    SSLEnv['SSL_SERVER_S_DN_O'] = \
      os.environ.get('SSL_SERVER_S_DN_O',
      os.environ.get('SSL_SERVER_O',
      ''))
    SSLEnv['SSL_SERVER_S_DN_OU'] = \
      os.environ.get('SSL_SERVER_S_DN_OU',
      os.environ.get('SSL_SERVER_OU',
      ''))
    SSLEnv['SSL_SERVER_S_DN_SP'] = \
      os.environ.get('SSL_SERVER_S_DN_SP',
      os.environ.get('SSL_SERVER_SP',
      ''))
    SSLEnv['SSL_SERVER_V_END'] = \
      os.environ.get('SSL_SERVER_V_END',
      os.environ.get('SSL_SERVER_CERT_END',
      ''))
    SSLEnv['SSL_SERVER_V_START'] = \
      os.environ.get('SSL_SERVER_V_START',
      os.environ.get('SSL_SERVER_CERT_START',
      ''))
    SSLEnv['SSL_VERSION_LIBRARY'] = \
      os.environ.get('SSL_VERSION_LIBRARY',
      os.environ.get('SSL_SSLEAY_VERSION',
      ''))

  return SSLEnv



##############################################################################
# Determine Security Level
##############################################################################

def SecLevel(acceptedciphers,valid_dn_regex='',valid_idn_regex=''):

  SSL_CIPHER = os.environ.get('SSL_CIPHER',
               os.environ.get('HTTPS_CIPHER',
	       ''))

  # SSL-Verbindung?
  if SSL_CIPHER and (SSL_CIPHER in acceptedciphers):

    SSL_CLIENT_S_DN = os.environ.get('SSL_CLIENT_S_DN',
		      os.environ.get('SSL_CLIENT_DN',
		      ''))

    if SSL_CLIENT_S_DN:

      SSL_CLIENT_I_DN = os.environ.get('SSL_CLIENT_I_DN',
			os.environ.get('SSL_CLIENT_IDN',
			''))

      dn_rm = re.compile(valid_dn_regex).match(SSL_CLIENT_S_DN)
      idn_rm = re.compile(valid_idn_regex).match(SSL_CLIENT_I_DN)
    
      if (dn_rm) and \
	 (idn_rm):
	return 2
      else:  
	return 1

    else:  
      return 1

  return 0


##############################################################################
# Print the SSL data in HTML format
##############################################################################

def PrintSecInfo(acceptedciphers,valid_dn_regex='',valid_idn_regex='',f=sys.stdout):

  seclevel = SecLevel(acceptedciphers,valid_dn_regex,valid_idn_regex)

  f.write("""<H3>Security level</H3><P>Current security level is: <STRONG>%d</STRONG></P>
           <TABLE NOBORDER CELLSPACING=5%%>
	   <TR>
	     <TD ALIGN=MIDDLE WIDTH=10%%>0</TD><TD>no encryption at all</TD>
	   </TR>
	   <TR>
	     <TD ALIGN=MIDDLE>1</TD>
	     <TD>Session is encrypted with SSL and cipher is accepted</TD>
	   </TR>
	   <TR>
	     <TD ALIGN=MIDDLE>2</TD>
	     <TD>Client presented valid certificate,<BR>
	     the DN of the certified object matches "<CODE>%s</CODE>"<BR>
	     and the DN of the certifier matches "<CODE>%s</CODE>"</TD>
	   </TR>
	   </TABLE>
	   """ % (seclevel,valid_dn_regex,valid_idn_regex))

  if seclevel>=1:

    SSL_CIPHER_ALGKEYSIZE = os.environ.get('SSL_CIPHER_ALGKEYSIZE',
                            os.environ.get('HTTPS_KEYSIZE',
			    os.environ.get('SSL_KEYSIZE',
			    os.environ.get('SSL_SERVER_KEY_SIZE',
			    ''))))
    SSL_CIPHER_EXPORT = os.environ.get('SSL_CIPHER_EXPORT',
                	os.environ.get('HTTPS_EXPORT',
			os.environ.get('SSL_EXPORT',
			'')))
    SSL_CIPHER = os.environ.get('SSL_CIPHER',
        	 os.environ.get('HTTPS_CIPHER',
		 ''))
    SSL_CIPHER_USEKEYSIZE = os.environ.get('SSL_CIPHER_USEKEYSIZE',
                            os.environ.get('HTTPS_SECRETKEYSIZE',
			    os.environ.get('SSL_SECKEYSIZE',
			    '')))
    SSL_SERVER_S_DN = os.environ.get('SSL_SERVER_S_DN',
		      os.environ.get('SSL_SERVER_DN',
		      ''))
    SSL_SERVER_I_DN = os.environ.get('SSL_SERVER_I_DN',
		      os.environ.get('SSL_SERVER_IDN',
		      ''))

    f.write("""You connected with cipher <STRONG>%s</STRONG>, key size <STRONG>%s Bit</STRONG>, actually used key size <STRONG>%s Bit</STRONG>.<P>
<H3>Server certificate</H3>
<TABLE>
  <TR>
    <TD>
      <DL>
	<DT>This certificate belongs to:</DT>
	<DD>%s</DD>
      </DL>
    </TD>
    <TD>
      <DL>
	<DT>This certificate was issued by:</DT>
	<DD>%s</DD>
      </DL>
    </TD>
  </TR>
</TABLE>
""" % (
  SSL_CIPHER,
  SSL_CIPHER_ALGKEYSIZE,
  SSL_CIPHER_USEKEYSIZE,
  string.join(string.split(charset.asn12html4(SSL_SERVER_S_DN),'/'),'<BR>'),
  string.join(string.split(charset.asn12html4(SSL_SERVER_I_DN),'/'),'<BR>')
))

  if seclevel>=2:

    SSL_CLIENT_I_DN = os.environ.get('SSL_CLIENT_I_DN',
			 os.environ.get('SSL_CLIENT_IDN',
			 ''))
    SSL_CLIENT_S_DN = os.environ.get('SSL_CLIENT_S_DN',
		      os.environ.get('SSL_CLIENT_DN',
		      ''))

    f.write("""<H3>Your client certificate</H3>
<TABLE>
  <TR>
    <TD>
      <DL>
	<DT>This certificate belongs to:</DT>
	<DD>%s</DD>
      </DL>
    </TD>
    <TD>
      <DL>
	<DT>This certificate was issued by:</DT>
	<DD>%s</DD>
      </DL>
    </TD>
  </TR>
</TABLE>
""" % (
  string.join(string.split(charset.asn12html4(SSL_CLIENT_S_DN),'/'),'<BR>'),
  string.join(string.split(charset.asn12html4(SSL_CLIENT_I_DN),'/'),'<BR>')
))

