########################################################################
# web2ldap
# (c) by Michael Stroeder, michael.stroeder@inka.de
# Distributed under GNU Public License (GPL)
# web-based LDAP Client, see http://www.web2ldap.de for details
########################################################################

import sys, string, cgiforms, ldapbase, web2ldapcnf, w2lcore

def HandleHTTPRequest(
  inf,
  outf,
  env
):

  http_accept_charset = env.get('HTTP_ACCEPT_CHARSET')
  if http_accept_charset and web2ldapcnf.print_rawutf8:
    if ('utf-8' in string.split(http_accept_charset,',')) or \
       (web2ldapcnf.print_rawutf8==2):
      accept_charset = 'utf-8'
    else:
      accept_charset = 'iso-8859-1'
  else:
    accept_charset = 'iso-8859-1'

  # form initialisieren
  form = cgiforms.formClass(inf,env,accept_charset)

  # Diese Felder werden eigentlich von fast allen Kommandos gebraucht
  form.add(cgiforms.formInputClass('ldap_sessionid','LDAP Session ID',255,'.*',size=25))
  form.add(cgiforms.formInputClass('ldap_binddn','Bind DN',255,'.*',size=40))
  form.add(cgiforms.formInputClass('ldap_bindpasswd','with Password',30,'.*',size=15))
  form.add(cgiforms.formInputClass('ldap_host','Host:Port',255,w2lcore.host_pattern,size=30))
  form.add(cgiforms.formInputClass('ldap_dn','DN',255,ldapbase.dn_pattern,size=25))
  form.add(cgiforms.formInputClass('ldap_url','LDAP URL',255,'.*',size=25))

  command = env.get('PATH_INFO',' ')[1:]
  try:

    if command=='searchform':
      import w2lsearchforms
      w2lsearchforms.w2l_SearchForm(outf,command,form)
    elif command=='filterform':
      import w2lsearchforms
      w2lsearchforms.w2l_FilterForm(outf,command,form)
    elif command in ['search','print','dsml','ldif']:
      import w2lsearch
      w2lsearch.w2l_Search(outf,command,form)
    elif command=='addform' or command=='modifyform':
      import w2laddmodifyform
      w2laddmodifyform.w2l_AddModifyForm(outf,command,form)
    elif command=='add':
      import w2ladd
      w2ladd.w2l_Add(outf,command,form)
    elif command=='modify':
      import w2lmodify
      w2lmodify.w2l_Modify(outf,command,form)
    elif command=='delete':
      import w2ldelete
      w2ldelete.w2l_Delete(outf,command,form)
    elif command=='modrdn':
      import w2lmodrdn
      w2lmodrdn.w2l_ModRDN(outf,command,form)
    elif command=='passwd':
      import w2lpasswd
      w2lpasswd.w2l_Passwd(outf,command,form)
    elif command=='read' or command=='vcard':
      import w2lread
      w2lread.w2l_Read(outf,command,form)
    elif command=='secinfo':
      import w2lsecinfo
      w2lsecinfo.w2l_SecInfo(outf,command,form)
    elif (command=='login') or (command==''):
      import w2llogin
      w2llogin.w2l_Login(outf,command,form)
    else:
      ldap_session = DoParams(command,form)
      raise ErrorExitClass(form,ldap_session,'Invalid web2ldap command <STRONG>%s</STRONG>!' % (command))

  except w2lcore.ErrorExitClass,e:

    w2lcore.PrintHeader(outf,'Error',form.accept_charset)
    w2lcore.MainMenuTable(outf,e.form,e.ldap_session)
    outf.write("""<DIV ID=MessageDiv>
  <H1>Error</H1>
    %s
    <BR>
    For questions or error reports contact:
    <A HREF="mailto:%s">%s</A>
</DIV>
""" % (e.Msg,env.get('SERVER_ADMIN',''),env.get('SERVER_ADMIN','')))
    w2lcore.PrintFooter(outf)
    # help garbage collection
    sys.exc_tracback = None
    e = None

  return

