########################################################################
# web2ldap
# (c) by Michael Stroeder, michael.stroeder@inka.de
# Distributed under GNU Public License (GPL)
# web-based LDAP Client, see http://www.web2ldap.de for details
########################################################################

import sys,web2ldapcnf

# Modules shipped with web2ldap
import cgiforms, charset, w2lcore

##############################################################################
# Login form
##############################################################################

def w2l_Login(outf,command,form):

  form.add(cgiforms.formInputClass('login_binddn','Bind DN',255,'.*',size=25))

  ldap_session = w2lcore.DoParams(command,form)
  ldap_host,ldap_binddn,ldap_bindpasswd,ldap_obj,ldap_defaults,ldap_url,ldap_dn = ldap_session

  if 'login_binddn' in form.inputkeys:
    ldap_binddn = w2lcore.input2utf(form.accept_charset,form.field['login_binddn'][0].content)

  w2lcore.PrintHeader(outf,'',form.accept_charset)
  outf.write("""<DIV ID=InputDiv>
<FORM ACTION="%s/searchform" METHOD="%s" ENCTYPE="application/x-www-form-urlencoded" ACCEPT-CHARSET="%s">
<H1>Login</H1>
<P>
  Simply press <STRONG>Login</STRONG> for anonymous access.
</P>
<P>
  <INPUT TYPE=SUBMIT VALUE="Login">
</P>
<TABLE NOBORDER CELLPADDING=0 CELLSPACING="5%%">
  <TR>
    <TD>Bind as</TD><TD><INPUT NAME="ldap_binddn" MAXLENGTH=200 SIZE=40 VALUE="%s"></TD>
  </TR>
  <TR>
    <TD>with password</TD><TD><INPUT TYPE="PASSWORD" NAME="ldap_bindpasswd" MAXLENGTH=100 SIZE=15 VALUE=""></TD>
  </TR>
""" % (form.script_name,web2ldapcnf.script_method,form.accept_charset,w2lcore.utf2display(form.accept_charset,ldap_binddn)))

  outf.write('<TR><TD>to host:port</TD><TD>')

  if not 'ldap_host' in form.inputkeys:
    ldap_host = ''

  if ldap_host and (not ldap_host in web2ldapcnf.ldap_host_list):
    outf.write('<INPUT NAME="ldap_host" MAXLENGTH=100 SIZE=30 VALUE="%s">' % (ldap_host))
  else:
    if len(web2ldapcnf.ldap_host_list)>1:
      outf.write('<SELECT NAME="ldap_host" SIZE=1>')
      for option in web2ldapcnf.ldap_host_list:
	outf.write('<OPTION%s>%s' % (' SELECTED'*(option==ldap_host),option))
      outf.write('</SELECT></TD></TR>')
      ldap_host = ''
    else:
      if web2ldapcnf.ldap_host_list:
        ldap_host = web2ldapcnf.ldap_host_list[0]
      else:
        ldap_host = ''
      outf.write('<INPUT NAME="ldap_host" MAXLENGTH=100 SIZE=30 VALUE="%s">' % (ldap_host))

  if ldap_host:
    if not ldap_dn:
      ldap_dn = charset.iso2utf(web2ldapcnf.ldap_def.get(ldap_host,{}).get('basedn',''))
    outf.write('<TR><TD>base DN</TD><TD><INPUT NAME="ldap_dn" MAXLENGTH=255 SIZE=30 VALUE="%s"></TD></TR>' % (ldap_dn))

  outf.write('</TD></TR></TABLE></FORM></DIV>')
  w2lcore.PrintFooter(outf)
