########################################################################
# web2ldap
# (c) by Michael Stroeder, michael.stroeder@inka.de
# Distributed under GNU Public License (GPL)
# web-based LDAP Client, see http://www.web2ldap.de for details
########################################################################

import string, cgiforms, charset, w2lcore
from web2ldapcnf import max_searchparams, script_method

def EndofSearchForm(outf,ldap_host,ldap_dn,ldap_binddn,ldap_bindpasswd,scopefield):

  outf.write("""
<P>
 Search root
 <INPUT NAME="ldap_dn" MAXLENGTH=200 SIZE=30 VALUE="%s">
 Scope %s
</P>
 <INPUT TYPE=HIDDEN NAME="ldap_binddn"     VALUE="%s">
 <INPUT TYPE=HIDDEN NAME="ldap_bindpasswd" VALUE="%s">
 <INPUT TYPE=HIDDEN NAME="ldap_host"       VALUE="%s">
 <INPUT TYPE="submit" VALUE="Search">
 <INPUT TYPE="reset" VALUE="Reset">
 </FORM>
</DIV>
""" % (
    ldap_dn,
    scopefield.inputfield(),
    ldap_binddn,
    ldap_bindpasswd,
    ldap_host
  ))

########################################################################
# Output a pretty search form
########################################################################

def w2l_SearchForm(outf,command,form):

  form.add(cgiforms.formFieldClass('search_params','Anzahl Suchangaben',2,'[0-9]+'))
  form.add(cgiforms.formSelectClass('search_scope','Scope',[('base','Base'),('one','One level'),('sub','Sub tree')],'sub'))

  ldap_session = w2lcore.DoParams(command,form)
  ldap_host,ldap_binddn,ldap_bindpasswd,ldap_obj,ldap_defaults,ldap_url,ldap_dn = ldap_session

  if not ldap_dn:
    ldap_dn = charset.iso2utf(ldap_defaults.get('basedn',''))
    ldap_session = ldap_host,ldap_binddn,ldap_bindpasswd,ldap_obj,ldap_defaults,ldap_url,ldap_dn

  if 'search_scope' in form.inputkeys:
    form.field['search_scope'][0].setdefault(form.field['search_scope'][0].content)

  w2lcore.PrintHeader(outf,'',form.accept_charset)
  w2lcore.MainMenuTable(outf,form,ldap_session)
  outf.write('<DIV ID=InputDiv><H1>Search form</H1>')

  if ('search_params' in form.inputkeys) and \
     form.field['search_params'][0].content:
    # Gewuenschte Anzahl der Suchparameter wurde angegeben
    rows = string.atoi(form.field['search_params'][0].content)
    if rows<1:                rows=1
    if rows>max_searchparams: rows=max_searchparams
  else:
    rows = 1

  # More und Fewer-Buttons ausgeben
  outf.write('<TABLE CELLPADDING="5%%" CELLSPACING=0><TR>')
  if rows<max_searchparams:
    outf.write('<TD>%s</TD>' % w2lcore.CommandButton(form,'searchform','More',w2lcore.utf2display(form.accept_charset,ldap_binddn),w2lcore.utf2display(form.accept_charset,ldap_bindpasswd),ldap_host,extrastr='<INPUT TYPE=HIDDEN NAME="search_params" VALUE="%d">' % (rows+1)))
  if rows>1:
    outf.write('<TD>%s</TD>' % w2lcore.CommandButton(form,'searchform','Fewer',w2lcore.utf2display(form.accept_charset,ldap_binddn),w2lcore.utf2display(form.accept_charset,ldap_bindpasswd),ldap_host,extrastr='<INPUT TYPE=HIDDEN NAME="search_params" VALUE="%d">' % (rows-1)))
  outf.write('<TD>search parameters</TD></TR></TABLE>')

  # Eigentliches Suchformular ausgeben
  outf.write("""<FORM ACTION="%s/search" METHOD="%s" ENCTYPE="application/x-www-form-urlencoded" ACCEPT-CHARSET="%s">
	   Match
	   <SELECT NAME="search_mode">
             <OPTION VALUE="(&amp;%%s)" SELECTED>all
             <OPTION VALUE="(|%%s)">any
	   </SELECT>
	   of the following.<BR>""" % (form.script_name,script_method,form.accept_charset))

  for i in range(rows):

    outf.write('<SELECT NAME="search_attr" SIZE=1>')

    for ind in range(len(w2lcore.search_attrkeys)):
      outf.write('  <OPTION%s>%s' % (' SELECTED'*(ind==i),w2lcore.search_attrkeys[ind]))

    outf.write('</SELECT>\n<SELECT NAME="search_option" SIZE=1>')

    for option in w2lcore.search_option.keys():
      outf.write('  <OPTION VALUE="%s" %s>%s' % (option,' SELECTED'*(option=='(%s=*%s*)'),w2lcore.search_option[option]))

    outf.write("""</SELECT>
	  <INPUT NAME="search_string" MAXLENGTH=60 SIZE=30 VALUE="">
	  <BR>
	  """)

  EndofSearchForm(outf,ldap_host,w2lcore.utf2display(form.accept_charset,ldap_dn),w2lcore.utf2display(form.accept_charset,ldap_binddn),w2lcore.utf2display(form.accept_charset,ldap_bindpasswd),form.field['search_scope'][0])

  w2lcore.PrintFooter(outf)


##############################################################################
# Ausgabe eines Filterformulars
##############################################################################

def w2l_FilterForm(outf,command,form):

  form.add(cgiforms.formInputClass('search_filterstr','Search filter string',120,'.*'))
  form.add(cgiforms.formSelectClass('search_scope','Scope',[('base','Base'),('one','One level'),('sub','Sub tree')],'sub'))

  ldap_session = w2lcore.DoParams(command,form)
  ldap_host,ldap_binddn,ldap_bindpasswd,ldap_obj,ldap_defaults,ldap_url,ldap_dn = ldap_session

  if not ldap_dn:
    ldap_dn = charset.iso2utf(ldap_defaults.get('basedn',''))
    ldap_session = ldap_host,ldap_binddn,ldap_bindpasswd,ldap_obj,ldap_defaults,ldap_url,ldap_dn

  if form.field['search_scope'][0].content:
    form.field['search_scope'][0].setdefault(form.field['search_scope'][0].content)

  w2lcore.PrintHeader(outf,'',form.accept_charset)
  w2lcore.MainMenuTable(outf,form,ldap_session)
  outf.write('<DIV ID=InputDiv><H1>Expert search</H1>')
  search_filterstr = form.field.get('search_filterstr',[])
  search_filterstr = search_filterstr[0].content
  outf.write("""<FORM ACTION="%s/search" METHOD="%s" ENCTYPE="application/x-www-form-urlencoded" ACCEPT-CHARSET="%s">
           LDAP filter string <INPUT NAME="search_filterstr" MAXLENGTH=120 SIZE=60 VALUE="%s">
	   """ % (form.script_name,script_method,form.accept_charset,search_filterstr))

  EndofSearchForm(outf,ldap_host,ldap_dn,ldap_binddn,ldap_bindpasswd,form.field['search_scope'][0])

  w2lcore.PrintFooter(outf)


