########################################################################
# web2ldap
# (c) by Michael Stroeder, michael.stroeder@inka.de
# Distributed under GNU Public License (GPL)
# web-based LDAP Client, see http://www.web2ldap.de for details
########################################################################

import web2ldapcnf,cgissl,w2lcore

##############################################################################
# Security info
##############################################################################

def w2l_SecInfo(outf,command,form):

  ldap_session = w2lcore.DoParams(command,form)
  ldap_host,ldap_binddn,ldap_bindpasswd,ldap_obj,ldap_defaults,ldap_url,ldap_dn = ldap_session

  w2lcore.PrintHeader(outf,'',form.accept_charset)
  w2lcore.MainMenuTable(outf,form,ldap_session)

  outf.write("""
<DIV ID=MessageDiv>
<H1>Security</H1>
<H2>LDAP</H2>
""")
  if ldap_binddn:
    outf.write('<TABLE><TR><TD>Host</TD><TD><STRONG>%s</STRONG></TD></TR><TR><TD>Bind-DN</TD><TD><STRONG>%s</STRONG></TD></TR></TABLE>' % (ldap_host,w2lcore.utf2display(form.accept_charset,ldap_binddn)))
  else:
    outf.write('Your using anonymous access on <STRONG>%s</STRONG>.' % (ldap_host))
  outf.write("""
<H2>HTTP Connection</H2>
<TABLE>
  <TR><TD>Your IP address:</TD><TD>%s</TD></TR>
  <TR><TD>Server signature:</TD><TD>%s</TD></TR>
</TABLE>
<H2>SSL Connection</H2>
""" % (form.env.get('REMOTE_ADDR','???'),form.env.get('SERVER_SIGNATURE','')))
  sec_valid_dn = ldap_defaults.get('sec_valid_dn','')
  sec_valid_idn = ldap_defaults.get('sec_valid_idn','')
  cgissl.PrintSecInfo(web2ldapcnf.sec_sslacceptedciphers,sec_valid_dn,sec_valid_idn,outf)
  outf.write('</DIV>')
  w2lcore.PrintFooter(outf)

